<?php

class PollManager extends PHPWS_Manager {

  var $poll;
  var $userbox_poll;

  
  function PollManager() {
    $this->setModule("poll");
    $this->setRequest("PHPWS_MAN_OP");
    $this->setTable("mod_poll");
    
    $this->init();
  }

  function menu() {
    $tags["SHOW_POLLS"] = PHPWS_Core::formSubmit("SHOW POLLS", "poll_op");
    $tags["NEW_POLL"] = PHPWS_Core::formSubmit("NEW POLL", "poll_op");
    
    $elements[0] = PHPWS_Core::formHidden("module", "poll");
    $elements[0] .= $GLOBALS["core"]->processTemplate($tags, "poll","menu.tpl");
    $content = PHPWS_Core::makeForm("poll", "index.php", $elements);
    return $content;														
  }
  
  function _list($id="polls") {
    $this->init();
    $content = $this->menu();
    $content .= $this->getList($id);
    $title = $id;
    $_SESSION["OBJ_layout"]->popbox($title, $content, NULL, "CNT_POLL");
  }
  
  function _getUsers() {
    $result = $GLOBALS["core"]->sqlSelect("mod_users", NULL, NULL, "username");
    $users[] = " ";
    
    if($result)
      foreach($result as $resultRow)
	$users[] = $resultRow["username"];
    return $users;
  }
  
  function _delete($ids) {
    $content = $this->menu();
    $title = $_SESSION['translate']->it("DELETE POLL");
    foreach($ids as $value) {
      $this->poll = new PHPWS_Poll($value);
      $this->poll->kill();
    }
    $content .= $_SESSION['translate']->it("Delete Successful");
    $_SESSION["OBJ_layout"]->popbox($title, $content, NULL,"CNT_POLL");
  }
  
  function _view($ids) {
    $content = $this->menu();
    $title = $_SESSION['translate']->it("VIEW POLLS");
    $_SESSION["OBJ_layout"]->popbox($title, $content, NULL,"CNT_POLL");
    foreach($ids as $value) {
      $this->poll = new PHPWS_Poll($value);
      $title = $this->poll->_label;
      $content = $this->poll->_body."\n";
      foreach($this->poll->_options as $option) {
	$content .= $option."\n";
      }
      $_SESSION["OBJ_layout"]->popbox($title, $content, NULL, "CNT_POLL");
    }
  }
  
  function _edit($ids) {
    $content = $this->menu();
    $title = $_SESSION['translate']->it("EDIT POLL");
    $_SESSION["OBJ_layout"]->popbox($title, $content, NULL,"CNT_POLL");
    $this->poll = new PHPWS_Poll($ids[0]);
    $this->poll->edit();
  }
  
  function showUserBox() {
    $sql = "SELECT id FROM mod_poll WHERE active='Yes'";
    $result = $GLOBALS["core"]->getOne($sql, TRUE);
    if(isset($result)) {
      $this->userbox_poll = new PHPWS_Poll($result);
      $this->userbox_poll->showUserBox();
    }
  }
  
  function action() {
    switch($_REQUEST["poll_op"]) {
    case "list":
      if ($_SESSION["OBJ_user"]->allow_access("poll", "view")) {
	$this->_list("polls");
      } else {
	$this->_error("access_denied");
      }
      break;
      
    case "NEW POLL":
      if ($_SESSION["OBJ_user"]->allow_access("poll", "create")) {
	$content = $this->menu();
	$title = "POLL";
	$_SESSION["OBJ_layout"]->popbox($title, $content, NULL, "CNT_POLL");
	
	$this->poll = new PHPWS_Poll;
	$this->poll->edit();
      } else {
	$this->_error("access_denied");
      }
      break;
      
    case "SHOW POLLS":
      if ($_SESSION["OBJ_user"]->allow_access("poll", "view")) {
	$this->_list("polls");
      } else {
	$this->_error("access_denied");
      }
      break;
      
    case "ADD":
      $content = $this->menu();
      $title = "NOTES";
      $_SESSION["OBJ_layout"]->popbox($title, $content, NULL, "CNT_POLL");
      $this->poll->edit();
      break;
      
    case "SUBMIT":
      $content = $this->menu();
      $title = "SUBMIT POLL";
      $_SESSION["OBJ_layout"]->popbox($title, $content, NULL, "CNT_POLL");
      $this->poll->send();
      break;
      
    case "VOTE":
      $this->userbox_poll->vote();
      break;
      
    case "result":
      $this->userbox_poll->showResult();
      break;
    }
  }
  
  function _error($type) {
    $title = "<font class=\"errortext\">" . $_SESSION["translate"]->it("ERROR!") . "</font>";
    switch($type) {
    case "access_denied":
      $content = $_SESSION["translate"]->it("ACCESS DENIED!");
      break;
    }
    $_SESSION["OBJ_layout"]->popbox($title, $content, NULL, "CNT_POLL");
  }
}
