#!/bin/sh

#
# Author: Jeremy Agee <jagee@tux.appstate.edu>
# Version: 0.1
#

# make sure your APACHE_USER and PHPWS_GROUP is set appropriately
# usually nobody or apache for the web server

# SEE: docs/SECURE.txt for details

APACHE_USER=apache
APACHE_GROUP=apache

echo ""
echo ----------------------------------------------------------------
echo $0
echo ""
echo Note: This script is for those without root access to their web servers.
echo If you have root access, use the other script.  It is more secure.
echo -----------------------------------------------------------------
echo ""

if [ $# -ne 1 ]; then
    echo Usage:
    echo $0 setup
    echo or
    echo $0 run
    echo ""
    echo Use \'setup\' before running the phpwebsite setup.
    echo Use \'run\' for normal phpwebsite operation.
    echo ""
    exit 127
fi

if [ "$1" == "setup" ]; then

    if [ -f ../.htaccess ]; then
      chmod 777 ../.htaccess
    fi

    find ../ -type d | xargs chmod 775
    find ../ -type f | xargs chmod 664
    chmod 775 *.sh

    chmod 777 ../conf/
    chmod -R 777 ../images/
    chmod -R 777 ../files/

    echo Permissions set!  Ready to run phpwebsite setup!

elif [ "$1" == "run" ]; then
    if [ -f ../.htaccess ]; then
      chmod 777 ../.htaccess
    else
      touch ../.htaccess
      chmod 777 ../.htaccess
    fi

    find ../ -type d | xargs chmod 775
    find ../ -type f | xargs chmod 664
    chmod 555 *.sh

    chmod 775 ../conf/
    chmod -R 777 ../images/
    chmod -R 777 ../files/
    chmod 777 ../conf/branch/

    echo Permissions Set!  Ready for normal operation!
fi

exit 0
