<?php

// You can remove the line below to attempt a lower version install.
// Anythink less than 4.1.2 probably will not run.
if (phpversion() < "4.2.2"){
  echo $_SESSION["translate"]->it("Sorry, but you appear to running PHP version") . " ".phpversion().". "
    . $_SESSION["translate"]->it("phpWebSite requires 4.2.2 or above") . ".<br />";
  exit();
}

if(isset($_SERVER['PATH_TRANSLATED'])) {
  $file_address = str_replace("setup/set_config.php", "", $_SERVER["PATH_TRANSLATED"]);
} else {
  $file_address = str_replace("setup/set_config.php", "", $_SERVER["SCRIPT_FILENAME"]); 
}


if ($_POST["step"]){
  $step = $_POST["step"];
}
else {
  $step = 1;
}
?>

<html>
<head>
<title>
Create Config File
</title>
</head>
<body>

<?php

echo "<div align=\"center\"><img src=\"poweredby.jpg\" /><br />";
if (file_exists("../conf/config.php")){
  echo "Your config.php file already exists. You will need to edit it by hand or move it to create another.";
  exit();
}

define("PHPWS_SOURCE_DIR", "../");

require_once ("../core/Core.php");
$core = new PHPWS_Core("noDB");
   $default_address = $_SERVER["SERVER_NAME"].str_replace("setup/set_config.php", "", $_SERVER["PHP_SELF"]);
 $core->seed_rand();
 $temp_hash = md5($file_address.rand());
   $dbversion = array ("mysql", "ibase", "mssql", "msql", "oci8", "odbc", "pgsql", "sybase");
 
if (!($hostname = $_POST["hostname"]))
     $hostname = "localhost";
     
if (!($username = $_POST["username"]))
     $username = "phpwebsite";
     
if (!($password = $_POST["password"]))
     $password = NULL;
 
if (!($database = $_POST["database"]))
   $database = "phpwebsite";
 
if (!($tbl_prefix = $_POST["tbl_prefix"]))
   $tbl_prefix = NULL;
 
if (!($http_src = $_POST["http_src"]))
   $http_src = $default_address;

if (!($filepath = $_POST["filepath"]))
   $filepath = $file_address;

if (!($hubhash = $_POST["hubhash"]))
   $hubhash = $temp_hash;

if (!($install_pass = $_POST["install_pass"]))
   $install_pass = NULL;

$http_src = str_replace("http://", "", $http_src);
if ("/" != substr($http_src, strlen($http_src) - 1 , 1))
   $http_src .= "/";

if ("/" != substr($filepath, strlen($filepath) - 1 , 1))
   $filepath .= "/";

$dataArray = $_POST;
$dataArray['http_src'] = $http_src;
$dataArray['filepath'] = $filepath;


switch ($step){
 case "1":

   echo "You are missing a config.php. I can help you create one.<br /><br />You need to set your directory permissions before you continue.  Read the /docs/secure.txt file for help on setting the correct permissions.<br /><br />$PEAR_Errors";

   echo "<form action=\"set_config.php\" method=\"post\">
".$core->formHidden("step", "2")."
";
   $table = new HTML_Table("cellpadding=\"6\" cellspacing=\"1\" bgcolor=\"black\"");
   $row0 = array("<b>Database Version</b>", $core->formSelect("dbversion", $dbversion, $_POST["dbversion"], 1), "Which SQL server you are using."); 
   $row1 = array("<b>Database Host</b>", $core->formTextField("hostname", $hostname, 20), "Leave as localhost if you are not sure.");
   $row2 = array("<b>Database User Name</b>", $core->formTextField("username", $username, 20), "User name for <b>database</b>. (We suggest you make one JUST for phpWebSite).");
   $row3 = array("<b>Database Password</b>", $core->formPassword("password", $password, 20), "Password for <b>database</b>.");
   $row4 = array("<b>Database Name</b>", $core->formTextField("database", $database, 20), "The name of your database.");
   $row5 = array("<b>Table Prefix</b>", $core->formTextField("tbl_prefix", $tbl_prefix, 20), "Leave blank if you don't require table prefixing.");
   $row6 = array("<b>Web Address</b>", $core->formTextField("http_src", $http_src, 50), "The web address to get to your site.");
   $row7 = array("<b>File Address</b>", $core->formTextField("filepath", $filepath, 50), "Where your phpWebSite files are located.");
   $row8 = array("<b>Hub Hash</b>", $core->formTextField("hubhash", $hubhash, 36), "Refresh this screen to create another or enter one of your own.");
   $row9 = array("<b>Install Password</b>", $core->formTextField("install_pass", $install_pass, 20), "Name this anything other than <i>default</i>.");

   $table->addRow($row0);
   $table->addRow($row1);
   $table->addRow($row2);
   $table->addRow($row3);
   $table->addRow($row4);
   $table->addRow($row5);
   $table->addRow($row6);
   $table->addRow($row7);
   $table->addRow($row8);
   $table->addRow($row9);

   $table->setRowAttributes(0, "bgcolor=\"#f7ca88\"");
   $table->setRowAttributes(1, "bgcolor=\"#82c9e5\"");
   $table->setRowAttributes(2, "bgcolor=\"#f7ca88\"");
   $table->setRowAttributes(3, "bgcolor=\"#82c9e5\"");
   $table->setRowAttributes(4, "bgcolor=\"#f7ca88\"");
   $table->setRowAttributes(5, "bgcolor=\"#82c9e5\"");
   $table->setRowAttributes(6, "bgcolor=\"#f7ca88\"");
   $table->setRowAttributes(7, "bgcolor=\"#82c9e5\"");
   $table->setRowAttributes(8, "bgcolor=\"#f7ca88\"");
   $table->setRowAttributes(9, "bgcolor=\"#82c9e5\"");

   echo $table->toHTML();
   echo "<br />" . $core->formSubmit("Create Config File");
   echo "</form>";
   break;

 case "2":
   include("./config.php");

   $config_info = config_maker($dataArray);

   $dbversion = preg_replace("/[^\w]/i", "", $dataArray['dbversion']);
   $username = preg_replace("/[^\w_0-9]/i", "", $dataArray['username']);
   $password = preg_replace("/[^\w_0-9]/i", "", $dataArray['password']);
   $hostname = preg_replace("/[^\w_0-9.\-]/i", "", $dataArray['hostname']);
   $database = preg_replace("/[^\w_0-9]/i", "", $dataArray['database']);

   $core->db = DB::connect("$dbversion://$username:$password@$hostname"."/".$database);
   /*
   if($core->db->message && $dbversion == "mysql")
     $core->db = DB::connect("$dbversion://$username:$password@$hostname/mysql");
   */

   $badPassWords = array("passwd", "password", "pass", "qwerty", "asdf", "admin", "phpws", "phpwebsite", "test", "asd", "passpass");

   if ($core->db->message)
     $error = "DB";
   elseif (empty($filepath) || !is_dir($filepath))
     $error = "badDir";
   elseif (empty($http_src))
     $error = "noAddress";
   elseif (empty($install_pass) || in_array($install_pass, $badPassWords))
     $error = "noPW";

   if(isset($error)) {
     $back = $_POST;
     $back["step"] = 1;

     echo "<span style=\"color : red ; font-weight :heavy\">";
     if ($error == "DB")
       echo "Unable to connect to your server's database.<br />";
     elseif ($error == "badDir")
       echo "The directory <b>$filepath</b> could not be found.<br />";
     elseif ($error == "noPW")
       echo "Your must enter an installation password and don't make it easy to guess.<br />";
     elseif ($error == "noAddress")
       echo "Your must enter a web address.<br />";

     echo "</span> Please reenter your settings.\n
<form action=\"set_config.php\" method=\"post\">
".$core->formHidden($back)."
".$core->formSubmit("Return to Setup")."
</form>";
     exit();
   }
 
 if ($core->writeFile("../conf/config.php", $config_info, NULL, 1)){
   echo "Configuration file saved under the name conf/config.php<br />After testing your installation, it would be best to make sure your conf/ directory is not writable.<br />";
   echo "Click ".$core->link($http_src . "setup/setup.php", "here")." to continue with the installation.<br />
Your installation password is the same as what you entered on the last screen.<br />";
 } else {
   $transfer = $_POST;
   unset($transfer["step"]);
   $transfer["print_config"] = "1";
   echo "Unable to save config.php file to ".$_POST["filepath"]."conf/<br /><br />";
   echo "You have two options:<br /><br />";
   echo "<b>Option 1</b><br />Click on the link below and cut and paste it into your newly created config.php file.<br />";
   echo $core->link($http_src . "setup/config.php", "Cut and Paste", NULL, $transfer)."<br /><br />";
   unset($transfer["print_config"]);

   $transfer["save_config"] = 1;
   echo "<b>Option 2</b><br />Right click on the link below and pick <b>Save Target As</b>. Then save the file as <b>config.php</b>. Upload the file to the \"conf\" directory in the phpWebSite root directory.<br />";
   echo $core->link($_POST["http_src"]."setup/config.php", "Right Click Me", NULL, $transfer);
   unset($transfer["save_config"]);
 }
 echo "<hr /><span style=\"color:red\">It is recommended that you rename, delete, or make inaccessible the set_config.php file once you have finished installation.</span>";
 break;
}

?>
</div>
</body>
</html>
